----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 12/02/2015 10:53:51 PM
-- Design Name: 
-- Module Name: LED_decoder - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity LED_dec is
    Port ( LED_en : in STD_LOGIC;
           sw : in STD_LOGIC_VECTOR (2 downto 0);
           ppl : out STD_LOGIC_VECTOR (6 downto 0));
end LED_dec;

architecture Behavioral of LED_dec is

begin
    process (LED_en, sw)
    begin
        if (LED_en = '1') then
            case sw is
                 when "000" => ppl <= "0000001";
                 when "001" => ppl <= "0000001";
                 when "010" => ppl <= "0000011";
                 when "011" => ppl <= "0000111";
                 when "100" => ppl <= "0001111";
                 when "101" => ppl <= "0011111";
                 when "110" => ppl <= "0111111";
                 when "111" => ppl <= "1111111";
                 when others => ppl <= "0000000";
             end case;
        end if;
        
        if (LED_en = '0') then
            ppl <= "0000000";
        end if;
    end process;

end Behavioral;
