----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 11/23/2015 02:50:00 PM
-- Design Name: 
-- Module Name: down_counter - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity counter is
  port( en, reset, clk : in  std_logic; 
        LED_en: out std_logic;
        Q : out std_logic_vector(5 downto 0));  
end counter; 

architecture Behavioral of counter is  
signal num: std_logic_vector(5 downto 0);
  
begin 
 
    process (en, reset, clk)  
        begin 
        if (en = '0') then
            LED_en <= '0';
        else
            LED_en <= '1'; 
        
            if(reset = '1') then
                num <= "111100";
            else
                if (rising_edge(clk)) then
                    if (num > 0) then
                        num <= num - 1;   
                    end if; 
                    if (num = 0) then
                        LED_en <= '0';
                    end if; 
                end if;
            end if;
         end if;
    end process;  
    Q <= num;  
end Behavioral;
